-- Lua is The Devil's Script
-- SimpleMp3 code maintained by Paradox
-- Co Author (and previous Maintainer) Riptides

-- Global Variables
SimpleMp3_Addon_Loaded = false;
SimpleMp3_UpdateInterval = 1.0;
SimpleMp3_ScrollUpdate = 0.4;
isPlaying = false;
isPlayingDemo = false;
demoLimit = 15;
isScrolling = true;
ScrollBackward = true;
ScrollForward = false;
TempList = {};
Count = 0;
Hr  = 0;
Min = 0;
Sec = 0;
Smp3_Length = 0;
Hr2  = 0;
Min2 = 0;
Sec2 = 0;
playDelay = 0;
-- Stop the music after a ReloadUI
function SimpleMp3_ReloadUI()
    -- SimpleMp3Form_StopMusic();
    -- SetCVar("Sound_EnableMusic", Smp3_Save.MuteOnStop);
end

-- Stop the music after logging out
function SimpleMp3_Logout()
    -- SimpleMp3Form_StopMusic();
    -- SetCVar("Sound_EnableMusic", Smp3_Save.MuteOnStop);
end

function SavedVariablesUpdate()
    if (Smp3_Save == nil) then
        Smp3_Save = {}
    end
    if (Smp3_Save.Volume == nil) then
        Smp3_Save.Volume = 0.5
    end
    if (Smp3_Save.Remaining == nil) then
        Smp3_Save.Remaining = false
    end
    if (Smp3_Save.MuteOnStop == nil) then
        Smp3_Save.MuteOnStop = 0
    end
    if (Smp3_Save.PlaySounds == nil) then
        Smp3_Save.PlaySounds = true
    end
    if (Smp3_Save.UseTags == nil) then
        Smp3_Save.UseTags = true
    end
    if (Smp3_Save.playOnStart == nil) then
        Smp3_Save.playOnStart = true
    end
    if (Smp3_Save.isShuffled == nil) then
        Smp3_Save.isShuffled = false
    end
    if (Smp3_Save.Current == nil) then
        Smp3_Save.Current = 1
    end
    if (Smp3_Save.VisibleSlots == nil) then
        Smp3_Save.VisibleSlots = 25
    end
    if (Smp3_Save.LIBVisibleSlots == nil) then
        Smp3_Save.LIBVisibleSlots = 25
    end
    if (Smp3_Save.ScrollText == nil) then
        Smp3_Save.ScrollText = SIMPLEMP3_DEFAULT_SCROLLTEXT
    end
    if (Smp3_Save.PlayListVersion == nil) then
        Smp3_Save.PlayListVersion = 0
    end
    if (Smp3_Save.BackupList == nil) then
        Smp3_Save.BackupList = {}
    end
    if (Smp3_Save.SimpleMp3PlayList == nil) then
        Smp3_Save.SimpleMp3PlayList = {}
    end
    if (Smp3_Save.sortList == nil) then
        Smp3_Save.sortList = 1
    end
    if (Smp3_Save.sortOrderPL == nil) then
        Smp3_Save.sortOrderPL = 1
    end
    if (Smp3_Save.sortFieldPL == nil) then
        Smp3_Save.sortFieldPL = 1
    end
    if (Smp3_Save.sortOrderLIB == nil) then
        Smp3_Save.sortOrderLIB = 1
    end
    if (Smp3_Save.sortFieldLIB == nil) then
        Smp3_Save.sortFieldLIB = 1
    end
    if (Smp3_Save.wasPlaying == nil) then
        Smp3_Save.wasPlaying = false
    end
    if (Smp3_Save.playDelay == nil) then
        Smp3_Save.playDelay = 5
    end
    if (Smp3_Save.wasVisibleMain == nil) then
        Smp3_Save.wasVisibleMain = false
    end
    if (Smp3_Save.wasVisibleVolume == nil) then
        Smp3_Save.wasVisibleVolume = false
    end
    if (Smp3_Save.wasVisibleLIB == nil) then
        Smp3_Save.wasVisibleLIB = false
    end
    if (Smp3_Save.wasVisiblePL == nil) then
        Smp3_Save.wasVisiblePL = false
    end
    if (Smp3_Save.changeVolumeInVC == nil) then
        Smp3_Save.changeVolumeInVC = true
    end
    if (Smp3_Save.nextTrack == nil) then
        Smp3_Save.nextTrack = false
    end
    if (Smp3_Save.showOutput == nil) then
        Smp3_Save.showOutput = true
    end
    if (Smp3_Save.showDebug == nil) then
        Smp3_Save.showDebug = false
    end
    return true
end

function SimpleMp3_Output(text, type)
    if (type == nil) then
        if (DEFAULT_CHAT_FRAME) and (Smp3_Save.showOutput == true) then
            DEFAULT_CHAT_FRAME:AddMessage(text,1,1,1);
        end
        UIErrorsFrame:AddMessage(text,1,0,1);
    elseif (type == "error") then
        if (DEFAULT_CHAT_FRAME) then
            DEFAULT_CHAT_FRAME:AddMessage(text,1,0,0);
            UIErrorsFrame:AddMessage(text,1,0,0);
        end
    elseif (type == "debug") then
        if (DEFAULT_CHAT_FRAME) and (Smp3_Save.showDebug == true) then
            DEFAULT_CHAT_FRAME:AddMessage(text,0,0,0);
        end
    end
end

function Time(sec)
    return SecondsToTime(sec);
end

function SliderMax(pln, num)
    if (pln <= num) then
        return (pln);
    else
        return (pln - num);
    end
end

function sortedpairs(t,comparator)
    local sortedKeys = {};
    table.foreach(t, function(k,v) table.insert(sortedKeys,k) end);
    table.sort(sortedKeys,comparator);
    local i = 0;
    local function _f(_s,_v)
        i = i + 1;
        local k = sortedKeys[i];
        if (k) then
            return k,t[k];
        end
    end
    return _f,nil,nil;
end

function tsort(t, field, direction)
    if (field == 1) then -- Name
        if (direction == 1) then
            function f(a,b) return string.lower(t[a].Name) < string.lower(t[b].Name); end
        elseif (direction == 2) then
            function f(a,b) return string.lower(t[a].Name) > string.lower(t[b].Name); end
        end
    elseif (field == 2) then -- Title
        if (direction == 1) then
            function f(a,b) return string.lower(t[a].Title) < string.lower(t[b].Title); end
        elseif (direction == 2) then
            function f(a,b) return string.lower(t[a].Title) > string.lower(t[b].Title); end
        end
    elseif (field == 3) then -- Artist
        if (direction == 1) then
            function f(a,b) return string.lower(t[a].Artist) < string.lower(t[b].Artist); end
        elseif (direction == 2) then
            function f(a,b) return string.lower(t[a].Artist) > string.lower(t[b].Artist); end
        end
    elseif (field == 4) then -- Album
        if (direction == 1) then
            function f(a,b) return string.lower(t[a].Album) < string.lower(t[b].Album); end
        elseif (direction == 2) then
            function f(a,b) return string.lower(t[a].Album) > string.lower(t[b].Album); end
        end
    elseif (field == 5) then -- Genre
        if (direction == 1) then
            function f(a,b) return string.lower(t[a].Genre) < string.lower(t[b].Genre); end
        elseif (direction == 2) then
            function f(a,b) return string.lower(t[a].Genre) > string.lower(t[b].Genre); end
        end
    elseif (field == 6) then -- Length
        if (direction == 1) then
            function f(a,b) return t[a].Length < t[b].Length; end
        elseif (direction == 2) then
            function f(a,b) return t[a].Length > t[b].Length; end
        end
    elseif (field == 7) then -- BitRate
        if (direction == 1) then
            function f(a,b) return t[a].BitRate < t[b].BitRate; end
        elseif (direction == 2) then
            function f(a,b) return t[a].BitRate > t[b].BitRate; end
        end
    elseif (field == 8) then -- Number (For PlayList removal)
        if (direction == 1) then
            function f(a,b) return t[a] < t[b]; end
        elseif (direction == 2) then
            function f(a,b) return t[a] > t[b]; end
        end
    end
    for k,v in sortedpairs(t, f) do
        tinsert(TempList, t[k])
    end
    if (t == Smp3_Save.SimpleMp3PlayList) then
        playing = SimpleMp3PlaylistForm_Info('name', Smp3_Save.Current)
        for i = 1, table.getn(t) do
            tremove(t)
        end
        for i = 1, table.getn(TempList) do
            tinsert(t, i, TempList[i]);
            if (t[i].Name == playing) then
                Smp3_Save.Current = i
            end
        end
        SimpleMp3Form_ResetDisplay(SimpleMp3PlaylistForm_Info('name', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('song', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('artist', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('album', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('length2', Smp3_Save.Current), Smp3_Save.Current, false);
    else
       for i = 1, table.getn(t) do
            tremove(t)
        end
        for i = 1, table.getn(TempList) do
            tinsert(t, TempList[i])
        end
    end
    for i = 1, table.getn(TempList) do
        tremove(TempList);
    end
    --TempList = {}
    collectgarbage();
end

-- wrappers for Titan Plugin (Suddendeath2000, please fix these)
function PLInfo(x, num)
 return SimpleMp3PlaylistForm_Info(x, num)
end
function SimpleMp3_PrevCLick()
	SimpleMp3_PrevClick()
end
