function SimpleMp3Form_TimeSwitch()
    if (Smp3_Save.Remaining) then
        Smp3_Save.Remaining = false
        SimpleMp3FormMp3Time:Hide()
        SimpleMp3FormMp3Time2:Show()
        SimpleMp3FormBnTimeSwitch:SetText("<<")
    else
        Smp3_Save.Remaining = true
        SimpleMp3FormMp3Time2:Hide()
        SimpleMp3FormMp3Time:Show()
        SimpleMp3FormBnTimeSwitch:SetText(">>")
    end
end

function SimpleMp3Form_TS_OnEnter()
    GameTooltip:SetText(SIMPLEMP3_TOOLTIP_TS_TITLE);
    GameTooltipTextLeft1:SetTextColor(1, 1, 1);
    GameTooltip:AddLine(SIMPLEMP3_TOOLTIP_TS_TEXT);
    GameTooltip:Show();
end

function SimpleMp3Form_OP_OnEnter()
    GameTooltip:SetText(SIMPLEMP3_TOOLTIP_OP_TITLE);
    GameTooltipTextLeft1:SetTextColor(1, 1, 1);
    GameTooltip:AddLine(SIMPLEMP3_TOOLTIP_OP_TEXT);
    GameTooltip:Show();
end

function SimpleMp3Form_OnLoad()
end

function SimpleMp3Form_OnShow()
    if (Smp3_Save.PlaySounds == true) then
        PlaySound("igCharacterInfoOpen");
    end
    Smp3_Save.wasVisibleMain = true;
    if (Smp3_Save.showOutput == true) then
        SetHideShowOutputBnText(SIMPLEMP3_HIDEOUTPUT_BN);
    else
        SetHideShowOutputBnText(SIMPLEMP3_SHOWOUTPUT_BN);
    end
    if (Smp3_Save.Remaining) then
        SimpleMp3FormBnTimeSwitch:SetText(">>")
    else
        SimpleMp3FormBnTimeSwitch:SetText("<<")
    end
end

function SimpleMp3Form_OnHide()
    if (SimpleMp3PlaylistForm:IsVisible()) then
        SimpleMp3PlaylistForm:Hide();
    end
    if (SimpleMp3VolumeForm:IsVisible()) then
        SimpleMp3VolumeForm:Hide();
    end
    if (SimpleMp3LibraryForm:IsVisible()) then
        SimpleMp3LibraryForm:Hide();
    end
    if (SimpleMp3Form:IsVisible()) then
        SimpleMp3Form:Hide();
    end
    Smp3_Save.wasVisibleMain = false;
end

function NowPlaying(name, song, artist, album, length, num)
    return SIMPLEMP3_NOWPLAY .. num .. ". " .. song .. " " .. SIMPLEMP3_BY .. " " .. artist .. " " .. SIMPLEMP3_FROM .. " " .. album .. " " .. length;
end

function SetScrollText(name, song, artist, album, length, num)
    if (song ~= 'Unknown') then
        Smp3_Save.ScrollText = "    " .. num .. ". " .. song .. " " .. SIMPLEMP3_BY .. " " .. artist .. " " .. SIMPLEMP3_FROM .. " " .. album .. " " .. length;
    else
        Smp3_Save.ScrollText = SIMPLEMP3_DEFAULT_SCROLLTEXT
    end
end

-- Text Scrolling
function ScrollNameLabel()
    LengthOfStr = string.len(Smp3_Save.ScrollText);
    if (LengthOfStr <= 40) then
        return;
    end
    if (ScrollBackward == true) then
        Count = Count + 1;

        SetNameLabel(string.sub(Smp3_Save.ScrollText, Count));

        if (Count == (LengthOfStr - 40)) then
            ScrollBackward = false;
            ScrollForward = true;
            isScrolling = true;
        end
    elseif (ScrollForward == true) then
        Count = Count - 1;

        SetNameLabel(string.sub(Smp3_Save.ScrollText, Count));

        if (Count == 1) then
            ScrollBackward = true;
            ScrollForward = false;
            isScrolling = true;
        end
    end
end

-- Sets the mp3 Name label text/color
function SetNameLabel(Text)
    local Name_Label;
    Name_Label = getglobal("SimpleMp3Form" .. "Mp3Name" .. "Label");
    Name_Label:SetText(Text);
    Name_Label:SetTextColor(0.50,1.0,1.0);  -- Blue
end

-- Sets the mp3 Time label text/color
function SetTimeLabel(Text)
    local Time_Label;
    Time_Label = getglobal("SimpleMp3Form" .. "Mp3Time" .. "Label");
    Time_Label:SetText(Text);
    Time_Label:SetTextColor(0.50,1.0,1.0);  -- Blue
end

-- Sets the mp3 Time label text/color
function SetTimeLabel2(Text)
    local Time_Label;
    Time_Label = getglobal("SimpleMp3Form" .. "Mp3Time2" .. "Label");
    Time_Label:SetText(Text);
    Time_Label:SetTextColor(0.50,1.0,1.0);  -- Blue
end

-- Hide/Show Output button
function SimpleMp3_HideShowOutputClick()
    SimpleMp3SetOutputClick();
end

-- sets the Hide/Show Output button text
function SetHideShowOutputBnText(Text)
    local HideShowBn;
    HideShowBn = getglobal("SimpleMp3Form" .. "BnHideShowOutput");
    HideShowBn:SetText(Text);
end

-- Play/Stop button
function SimpleMp3_PlayStopClick()
    if (Smp3_Save.PlaySounds == true) then
        PlaySound("igMiniMapZoomIn");
    end
    if (isPlaying == true) then -- stop music
            SimpleMp3Form_StopMusic();
    elseif (isPlaying == false) then -- start music
        Smp3_Length = SimpleMp3PlaylistForm_Info('length', Smp3_Save.Current);
        SimpleMp3Form_StartMusic(SimpleMp3PlaylistForm_Info('name', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('song', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('artist', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('album', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('length2', Smp3_Save.Current), Smp3_Save.Current, true);
    end
end

-- sets the play/stop button text
function SetPlayStopBnText(Text)
    local PlayStopBn;
    PlayStopBn = getglobal("SimpleMp3Form" .. "BnPlayStop");
    PlayStopBn:SetText(Text);
end

--sets the Shuffle button text
function SetShuffleBnText(Text)
    local ShuffleBn;
    ShuffleBn = getglobal("SimpleMp3Form" .. "BnShuffle");
    ShuffleBn:SetText(Text);
end

-- resets the display
function SimpleMp3Form_ResetDisplay(name, song, artist, album, length, num, full)
    if (full) then
        Hr  = 00;
        Min = 00;
        Sec = 00;
        Hr2  = 00;
        Min2 = 00;
        Sec2 = 00;
    end
    Count = 0;
    ScrollBackward = true;
    ScrollForward = false;
    SetScrollText(name, song, artist, album, length, num);
    SetNameLabel(Smp3_Save.ScrollText);
    isScrolling = true;
end

function SimpleMp3Form_StopMusic()
    StopMusic();
    SetCVar("Sound_EnableMusic", Smp3_Save.MuteOnStop);
    isPlaying = false;
    SimpleMp3Form_ResetDisplay(SimpleMp3PlaylistForm_Info('name', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('song', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('artist', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('album', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('length2', Smp3_Save.Current), Smp3_Save.Current, true);
    SetPlayStopBnText(SIMPLEMP3_BINDPLAY);
end

function SimpleMp3Form_StartMusic(name, song, artist, album, length, num, fullreset)
    if (Smp3_Save.SimpleMp3PlayList[1]) then
        MaxPlayListNum = table.getn(Smp3_Save.SimpleMp3PlayList);
    else
        MaxPlayListNum = 0;
    end
    if (isPlayingDemo == false) then
        if (MaxPlayListNum == 0) then
            return;
        end
        isPlaying = true;
    end
    SetCVar("Sound_EnableMusic", 1);
    SimpleMp3Form_ResetDisplay(name, song, artist, album, length, num, fullreset);
    if (isPlayingDemo == false) then
        if (Smp3_Length > 3599) then
            local junk1, junk2, junk3, junk4, junk5, junk6 = strsplit(" ", length);
            if (junk1 == nil) then
                Hr2 = 0;
            else
                Hr2 = tonumber(junk1);
            end
            if (junk3 == nil) then
                Min2 = 0;
            else
                Min2 = tonumber(junk3);
            end
            if (junk5 == nil) then
                Sec2 = 0;
            else
                Sec2 = tonumber(junk5);
            end
        elseif (Smp3_Length > 59) then
            Hr2 = 0;
            local junk3, junk4, junk5, junk6 = strsplit(" ", length);
            if (junk3 == nil) then
                Min2 = 0;
            else
                Min2 = tonumber(junk3);
            end
            if (junk5 == nil) then
                Sec2 = 0;
            else
                Sec2 = tonumber(junk5);
            end
        else
            Hr2 = 0;
            Min2 = 0;
            local junk5, junk6 = strsplit(" ", length);
            if (junk5 == nil) then
                Sec2 = 0;
            else
                Sec2 = tonumber(junk5);
            end
        end
    else
        if (Smp3_Length >= demoLimit) then
            local limit = Time(demoLimit);
            if (demoLimit > 3599) then
                local junk1, junk2, junk3, junk4, junk5, junk6 = strsplit(" ", limit);
                if (junk1 == nil) then
                    Hr2 = 0;
                else
                    Hr2 = tonumber(junk1);
                end
                if (junk3 == nil) then
                    Min2 = 0;
                else
                    Min2 = tonumber(junk3);
                end
                if (junk5 == nil) then
                    Sec2 = 0;
                else
                    Sec2 = tonumber(junk5);
                end
            elseif (demoLimit > 59) then
                Hr2 = 0;
                local junk3, junk4, junk5, junk6 = strsplit(" ", limit);
                if (junk3 == nil) then
                    Min2 = 0;
                else
                    Min2 = tonumber(junk3);
                end
                if (junk5 == nil) then
                    Sec2 = 0;
                else
                    Sec2 = tonumber(junk5);
                end
            else
                Hr2 = 0;
                Min2 = 0;
                local junk5, junk6 = strsplit(" ", limit);
                if (junk5 == nil) then
                    Sec2 = 0;
                else
                    Sec2 = tonumber(junk5);
                end
            end
        else
            if (Smp3_Length > 3599) then
                local junk1, junk2, junk3, junk4, junk5, junk6 = strsplit(" ", length);
                if (junk1 == nil) then
                    Hr2 = 0;
                else
                    Hr2 = tonumber(junk1);
                end
                if (junk3 == nil) then
                    Min2 = 0;
                else
                    Min2 = tonumber(junk3);
                end
                if (junk5 == nil) then
                    Sec2 = 0;
                else
                    Sec2 = tonumber(junk5);
                end
            elseif (Smp3_Length > 59) then
                Hr2 = 0;
                local junk3, junk4, junk5, junk6 = strsplit(" ", length);
                if (junk3 == nil) then
                    Min2 = 0;
                else
                    Min2 = tonumber(junk3);
                end
                if (junk5 == nil) then
                    Sec2 = 0;
                else
                    Sec2 = tonumber(junk5);
                end
            else
                Hr2 = 0;
                Min2 = 0;
                local junk5, junk6 = strsplit(" ", length);
                if (junk5 == nil) then
                    Sec2 = 0;
                else
                    Sec2 = tonumber(junk5);
                end
            end
        end
    end
    collectgarbage();
    SimpleMp3_Output(NowPlaying(name, song, artist, album, length, num));
    SetPlayStopBnText(SIMPLEMP3_BINDSTOP);
    PlayMusic(name);
end

function SimpleMp3_RemoveCurrentClick()
    SimpleMp3Playlist_Remove(Smp3_Save.Current);
end

-- next button
function SimpleMp3_NextClick()
    if (Smp3_Save.PlaySounds == true) then
        PlaySound("igMiniMapZoomIn");
    end
    if (Smp3_Save.SimpleMp3PlayList[1]) then
        MaxPlayListNum = table.getn(Smp3_Save.SimpleMp3PlayList);
    else
        MaxPlayListNum = 1;
    end
    if (MaxPlayListNum == 1) then
        if (Smp3_Save.SimpleMp3PlayList[1] == nil) then
            return;
        end
    end

    if (Smp3_Save.Current == MaxPlayListNum) then
        Smp3_Save.Current = 1;
    else
        Smp3_Save.Current = Smp3_Save.Current + 1;
    end

    if (isPlaying == true) then
        SimpleMp3Form_StopMusic();
        Smp3_Length = SimpleMp3PlaylistForm_Info('length', Smp3_Save.Current);
        SimpleMp3Form_StartMusic(SimpleMp3PlaylistForm_Info('name', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('song', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('artist', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('album', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('length2', Smp3_Save.Current), Smp3_Save.Current, true);
    else
        Smp3_Length = SimpleMp3PlaylistForm_Info('length', Smp3_Save.Current);
        SimpleMp3Form_ResetDisplay(SimpleMp3PlaylistForm_Info('name', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('song', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('artist', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('album', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('length2', Smp3_Save.Current), Smp3_Save.Current, true);
    end
end

-- prev button
function SimpleMp3_PrevClick()
    if (Smp3_Save.PlaySounds == true) then
        PlaySound("igMiniMapZoomIn");
    end
    if (Smp3_Save.SimpleMp3PlayList[1]) then
        MaxPlayListNum = table.getn(Smp3_Save.SimpleMp3PlayList);
    else
        MaxPlayListNum = 1;
    end
    if (MaxPlayListNum == 1) then
        if (Smp3_Save.SimpleMp3PlayList[1] == nil) then
            return;
        end
    end

    if (Smp3_Save.Current == 1) then
        Smp3_Save.Current = MaxPlayListNum;
    else
        Smp3_Save.Current = Smp3_Save.Current - 1;
    end

    if (isPlaying == true) then
        SimpleMp3Form_StopMusic();
        Smp3_Length = SimpleMp3PlaylistForm_Info('length', Smp3_Save.Current);
        SimpleMp3Form_StartMusic(SimpleMp3PlaylistForm_Info('name', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('song', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('artist', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('album', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('length2', Smp3_Save.Current), Smp3_Save.Current, true);
    else
        Smp3_Length = SimpleMp3PlaylistForm_Info('length', Smp3_Save.Current);
        SimpleMp3Form_ResetDisplay(SimpleMp3PlaylistForm_Info('name', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('song', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('artist', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('album', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('length2', Smp3_Save.Current), Smp3_Save.Current, true);
    end
end

-- Shuffle Button
function SimpleMp3_ShuffleClick()
    if (Smp3_Save.PlaySounds == true) then
        PlaySound("igMiniMapZoomIn");
    end
    playing = SimpleMp3PlaylistForm_Info('name', Smp3_Save.Current)
    if (Smp3_Save.isShuffled == false) then
        if (Smp3_Save.SimpleMp3PlayList[1]) then
            for i = 1, table.getn(Smp3_Save.SimpleMp3PlayList) do
                tinsert(Smp3_Save.BackupList, i, Smp3_Save.SimpleMp3PlayList[i]);
            end
            for i = 1, table.getn(Smp3_Save.SimpleMp3PlayList) do
                local x = math.random(1,table.getn(Smp3_Save.SimpleMp3PlayList));
                tinsert(TempList, Smp3_Save.SimpleMp3PlayList[x]);
                tremove(Smp3_Save.SimpleMp3PlayList,x);
            end
            for i = 1, table.getn(TempList) do
                tinsert(Smp3_Save.SimpleMp3PlayList, i, TempList[i]);
                if (Smp3_Save.SimpleMp3PlayList[i].Name == playing) then
                    Smp3_Save.Current = i
                end
            end
            for i = 1, table.getn(TempList) do
                tremove(TempList);
            end

            Smp3_Save.isShuffled = true;
            if (isPlaying == true) then
                SimpleMp3Form_ResetDisplay(SimpleMp3PlaylistForm_Info('name', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('song', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('artist', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('album', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('length2', Smp3_Save.Current), Smp3_Save.Current, false);
            else
                SimpleMp3Form_ResetDisplay(SimpleMp3PlaylistForm_Info('name', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('song', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('artist', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('album', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('length2', Smp3_Save.Current), Smp3_Save.Current, true);
            end
            SetShuffleBnText(SIMPLEMP3_BINDSHUFFLEON)
            SimpleMp3_Output(SIMPLEMP3_SHUFFLEON);
        else
            collectgarbage();
            return
        end
    elseif (Smp3_Save.isShuffled == true) then
        if (Smp3_Save.SimpleMp3PlayList[1]) then
            for i = 1, table.getn(Smp3_Save.SimpleMp3PlayList) do
                tremove(Smp3_Save.SimpleMp3PlayList);
            end
            for i = 1, table.getn(Smp3_Save.BackupList) do
                tinsert(Smp3_Save.SimpleMp3PlayList, i, Smp3_Save.BackupList[i]);
                if (Smp3_Save.SimpleMp3PlayList[i].Name == playing) then
                    Smp3_Save.Current = i
                end
            end
            for i = 1, table.getn(Smp3_Save.BackupList) do
                tremove(Smp3_Save.BackupList);
            end

            Smp3_Save.isShuffled = false;
            if (isPlaying == true) then
                SimpleMp3Form_ResetDisplay(SimpleMp3PlaylistForm_Info('name', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('song', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('artist', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('album', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('length2', Smp3_Save.Current), Smp3_Save.Current, false);
            else
                SimpleMp3Form_ResetDisplay(SimpleMp3PlaylistForm_Info('name', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('song', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('artist', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('album', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('length2', Smp3_Save.Current), Smp3_Save.Current, true);
            end
            SetShuffleBnText(SIMPLEMP3_BINDSHUFFLEOFF)
            SimpleMp3_Output(SIMPLEMP3_SHUFFLEOFF);
        else
            collectgarbage();
            return;
        end
    end
    collectgarbage();
end

-- Playlist Button
function Playlist_button()
    if (SimpleMp3PlaylistForm:IsVisible()) then
       SimpleMp3PlaylistForm:Hide();
    else
       SimpleMp3PlaylistForm:Show();
    end
end

-- Library Button
function Library_button()
    if (SimpleMp3LibraryForm:IsVisible()) then
       SimpleMp3LibraryForm:Hide();
    else
       SimpleMp3LibraryForm:Show();
    end
end
