SimpleMp3LibraryTemp = {}
------------------------------------------------------
-- Library Functions
------------------------------------------------------

function SimpleMp3LibraryForm_Info(x, num)
    if (SimpleMp3Library) then
        if (x == 'song') then
            if (SimpleMp3Library[num].Title == 'None') then
                return string.gsub(SimpleMp3Library[num].Name, "^.+\\", "");
            else
                return SimpleMp3Library[num].Title;
            end
        elseif (x == 'artist') then
            if (SimpleMp3Library[num].Artist == 'None') then
                return SIMPLEMP3_UNK_ARTIST;
            else
                return SimpleMp3Library[num].Artist;
            end
        elseif (x == 'album') then
            if (SimpleMp3Library[num].Album == 'None') then
                return SIMPLEMP3_UNK_ALBUM;
            else
                return SimpleMp3Library[num].Album;
            end
        elseif (x == 'genre') then
            if (SimpleMp3Library[num].Genre == 'None') then
                return SIMPLEMP3_UNK_GENRE;
            else
                return SimpleMp3Library[num].Genre;
            end
        elseif (x == 'bitrate') then
            if (SimpleMp3Library[num].BitRate == 'None') then
                return SIMPLEMP3_UNK_BITRATE;
            else
                return SimpleMp3Library[num].BitRate;
            end
        elseif (x == 'name') then
            return SimpleMp3Library[num].Name;
        elseif (x == 'name2') then
            return string.gsub(SimpleMp3Library[num].Name, "^.+\\", "");
        elseif (x == 'length') then
            return SimpleMp3Library[num].Length;
        elseif (x == 'length2') then
            return Time(SimpleMp3Library[num].Length);
        end
    else
        return SIMPLEMP3_UNK
    end
end

function SimpleMp3LibraryForm_Display(num)
    if (Smp3_Save.UseTags == true) then
        return SimpleMp3LibraryForm_Info('song', num) .. " " .. "|cFFFFFFFF" .. SimpleMp3LibraryForm_Info('artist', num) .. " " .. "|r" .. SimpleMp3LibraryForm_Info('album', num) .. " " .. "|cFFFFFFFF" .. SimpleMp3LibraryForm_Info('genre', num) .. " " .. "|r" .. SimpleMp3LibraryForm_Info('bitrate', num) .. "k " .. "|cFFFFFFFF" .. SimpleMp3LibraryForm_Info('length2', num) .. "|r";
    else
        return SimpleMp3LibraryForm_Info('name2', num) .. " " .. SimpleMp3LibraryForm_Info('length2', num);
    end
end

-- Library Onshow tells it to update
function SimpleMp3LibraryForm_OnShow()
    if (Smp3_Save.PlaySounds == true) then
        PlaySound("igCharacterInfoOpen");
    end
    Smp3_Save.wasVisibleLIB = true;
    SimpleMp3LibraryForm_Update()
end

function SimpleMp3LibraryForm_OnHide()
    if (Smp3_Save.PlaySounds == true) then
            PlaySound("igCharacterInfoClose");
    end
    Smp3_Save.wasVisibleLIB = false;
end

 -- When the scrollbar is changed so shall the list
function SimpleMp3LibraryForm_OnValueChanged()
    SimpleMp3LibraryForm_Update()
end

function SimpleMp3LibraryForm_OnLoad()
    local LabelVar;
    LabelVar = getglobal("SimpleMp3LibraryForm".. "TitleLabel" .. "Label");
    LabelVar:SetText(SIMPLEMP3_BINDLIBRARY);
    LabelVar = getglobal("SimpleMp3LibraryForm" .. "Button1");
    LabelVar:SetText(SIMPLEMP3_BINDADDALL_BN);
    LabelVar = getglobal("SimpleMp3LibraryForm" .. "Button2");
    LabelVar:SetText(SIMPLEMP3_BINDADDSEL_BN);
    LabelVar = getglobal("SimpleMp3LibraryForm" .. "Button3");
    LabelVar:SetText(SIMPLEMP3_SORTNAME);
    LabelVar = getglobal("SimpleMp3LibraryForm" .. "Button4");
    LabelVar:SetText(SIMPLEMP3_SORTTITLE);
    LabelVar = getglobal("SimpleMp3LibraryForm" .. "Button5");
    LabelVar:SetText(SIMPLEMP3_SORTARTIST);
    LabelVar = getglobal("SimpleMp3LibraryForm" .. "Button6");
    LabelVar:SetText(SIMPLEMP3_SORTALBUM);
    LabelVar = getglobal("SimpleMp3LibraryForm" .. "Button7");
    LabelVar:SetText(SIMPLEMP3_SORTGENRE);
    LabelVar = getglobal("SimpleMp3LibraryForm" .. "Button8");
    LabelVar:SetText(SIMPLEMP3_SORTLENGTH);
    LabelVar = getglobal("SimpleMp3LibraryForm" .. "Button9");
    LabelVar:SetText(SIMPLEMP3_SORTBITRATE);
    this:RegisterForDrag("LeftButton");
end

function SimpleMp3LibraryForm_OnEvent()
end

-- Library form populates the list according to window size
function SimpleMp3LibraryForm_PopulateList()
    local LabelVar, SliderVar;
    SliderVar = getglobal("SimpleMp3LibraryForm" .. "ListSlider");
    MaxLibraryNum = table.getn(SimpleMp3Library);

    if (MaxLibraryNum == 1) then
        LabelVar = getglobal("SimpleMp3LibraryForm" .. "PanelBn" .. 1);
        LabelVar:SetText(SliderVar:GetValue() + 0 .. ". " .. SimpleMp3LibraryForm_Display(SliderVar:GetValue() + 0));
        elseif (Smp3_Save.LIBVisibleSlots <= MaxLibraryNum) then
        for i=1,Smp3_Save.LIBVisibleSlots do
            LabelVar = getglobal("SimpleMp3LibraryForm" .. "PanelBn" .. i);
            LabelVar:SetText(SliderVar:GetValue() + (i - 1) .. ". " .. SimpleMp3LibraryForm_Display(SliderVar:GetValue() + (i - 1)));
        end
    else
        for i=1,MaxLibraryNum do
            LabelVar = getglobal("SimpleMp3LibraryForm" .. "PanelBn" .. i);

            if (i > MaxLibraryNum) then
                return;
            end

            -- Debugging purposes while fixing playlist resizing issue
            SimpleMp3_Output(SliderVar:GetValue() .. " " .. i .. " " .. SimpleMp3Library[(SliderVar:GetValue() + i) - 1].Name, "debug");
            LabelVar:SetText(SliderVar:GetValue() + (i - 1) .. ". " .. SimpleMp3LibraryForm_Display(SliderVar:GetValue() + (i - 1)));
        end
    end
end

-- Library update (text show/hide routine)
-- This tells the resizable window how many slots are viewable at that size
function SimpleMp3LibraryForm_Update()
    if (SimpleMp3_Addon_Loaded == true) then
        local fheight = SimpleMp3LibraryForm:GetHeight()
        local SliderVar;
        if (SimpleMp3Library) then
            MaxLibraryNum = table.getn(SimpleMp3Library);
            SliderVar = getglobal("SimpleMp3LibraryForm" .. "ListSlider");
            for i = 1, 25 do
                if (MaxLibraryNum >= i) then
                    if ((i * 14) + 37.8 < fheight) then
                        x = 'SimpleMp3LibraryFormPanelBn' .. i .. ':Show()'
                        RunScript(x)
                        SliderVar:SetMinMaxValues(1, SliderMax(table.getn(SimpleMp3Library), (i-1)));
                        Smp3_Save.LIBVisibleSlots = i;
                    else
                        x = 'SimpleMp3LibraryFormPanelBn' .. i .. ':Hide()'
                        RunScript(x)
                    end
                else
                    x = 'SimpleMp3LibraryFormPanelBn' .. i .. ':Hide()'
                    RunScript(x)
                end
            end
        end

        -- Debugging purposes while fixing library issues
        -- SimpleMp3_Output(fheight, "debug");

        SimpleMp3LibraryForm_PopulateList()
    end
end

-- Function for when something in the Library is clicked
function SimpleMp3LibraryForm_OnClick(MouseButton, Number)
    if (SimpleMp3Library) then
        local SliderVar;
        SliderVar = getglobal("SimpleMp3LibraryForm" .. "ListSlider");
        LIBCurrent = (SliderVar:GetValue() + Number - 1);

        if (MouseButton == 'LeftButton' and IsControlKeyDown()) then
            if (Smp3_Save.PlaySounds == true) then
                PlaySound("igMiniMapZoomIn");
            end
            tinsert(SimpleMp3LibraryTemp, SimpleMp3Library[LIBCurrent]);
            SimpleMp3_Output("Added " .. SimpleMp3LibraryTemp[LIBCurrent].Name, "debug");
        elseif (MouseButton == 'LeftButton' and IsShiftKeyDown()) then
            if (Smp3_Save.PlaySounds == true) then
                PlaySound("igMiniMapZoomIn");
            end
            if (isPlaying) then
                SimpleMp3Form_StopMusic();
            end
            isPlayingDemo = true;
            Smp3_Length = SimpleMp3LibraryForm_Info('length', LIBCurrent);
            SimpleMp3Form_StartMusic(SimpleMp3LibraryForm_Info('name', LIBCurrent), SimpleMp3LibraryForm_Info('song', LIBCurrent), SimpleMp3LibraryForm_Info('artist', LIBCurrent), SimpleMp3LibraryForm_Info('album', LIBCurrent), SimpleMp3LibraryForm_Info('length2', LIBCurrent), 'demo', true); -- FIXME
        elseif (MouseButton == 'LeftButton') then
            if (Smp3_Save.isShuffled == true) then
                SimpleMp3_Output(SIMPLEMP3_CANT_ADD, "error");
            else
                if (Smp3_Save.PlaySounds == true) then
                    PlaySound("igMiniMapZoomIn");
                end
                tinsert(Smp3_Save.SimpleMp3PlayList, SimpleMp3Library[LIBCurrent]);
            end
        end
        SimpleMp3LibraryForm_Update()
    end
end

-- Library scroll function
function SimpleMp3LibraryForm_OnMouseWheel(Direction)
    local SliderVar;
    SliderVar = getglobal("SimpleMp3LibraryForm" .. "ListSlider");

    if (Direction == 1) then
        SliderVar:SetValue(SliderVar:GetValue() - 1);
    else
        SliderVar:SetValue(SliderVar:GetValue() + 1);
    end
end

-- Function to Add All songs to the PlayList
function SimpleMp3LibraryForm_Button1()
    for i = 1, table.getn(SimpleMp3Library) do
           tinsert(Smp3_Save.SimpleMp3PlayList, table.getn(Smp3_Save.SimpleMp3PlayList) + 1, SimpleMp3Library[i]);
    end
    SimpleMp3_Output("Added all songs to Playlist", "debug");
    SimpleMp3Form_ResetDisplay(SimpleMp3PlaylistForm_Info('name', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('song', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('artist', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('album', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('length2', Smp3_Save.Current), Smp3_Save.Current, false);
    SimpleMp3LibraryForm_Update()
    collectgarbage();
end

-- Function to Add All Selected songs to the PlayList
function SimpleMp3LibraryForm_Button2()
    if (SimpleMp3LibraryTemp == nil) then
        return
    end
    if (Smp3_Save.isShuffled == true) then
        SimpleMp3_Output(SIMPLEMP3_CANT_ADD, "error");
    else
        for i = 1, table.getn(SimpleMp3LibraryTemp) do
            tinsert(Smp3_Save.SimpleMp3PlayList, table.getn(Smp3_Save.SimpleMp3PlayList) + 1, SimpleMp3LibraryTemp[i]);
            SimpleMp3_Output("Added " .. SimpleMp3LibraryTemp[i].Name, "debug");
        end
        for i = 1, table.getn(SimpleMp3LibraryTemp) do
            tremove(SimpleMp3LibraryTemp)
        end
        collectgarbage();
    end
end

-- Function to sort by name
function SimpleMp3LibraryForm_Button3()
  Smp3_Save.sortFieldLIB = 1
  Smp3_Save.sortOrderLIB = 1
  tsort(SimpleMp3Library, Smp3_Save.sortFieldLIB, Smp3_Save.sortOrderLIB)
end

-- Function to sort by title
function SimpleMp3LibraryForm_Button4()
  Smp3_Save.sortFieldLIB = 2
  Smp3_Save.sortOrderLIB = 1
  tsort(SimpleMp3Library, Smp3_Save.sortFieldLIB, Smp3_Save.sortOrderLIB)
end

-- Function to sort by artist
function SimpleMp3LibraryForm_Button5()
  Smp3_Save.sortFieldLIB = 3
  Smp3_Save.sortOrderLIB = 1
  tsort(SimpleMp3Library, Smp3_Save.sortFieldLIB, Smp3_Save.sortOrderLIB)
end

-- Function to sort by album
function SimpleMp3LibraryForm_Button6()
  Smp3_Save.sortFieldLIB = 4
  Smp3_Save.sortOrderLIB = 1
  tsort(SimpleMp3Library, Smp3_Save.sortFieldLIB, Smp3_Save.sortOrderLIB)
end

-- Function to sort by genre
function SimpleMp3LibraryForm_Button7()
  Smp3_Save.sortFieldLIB = 5
  Smp3_Save.sortOrderLIB = 1
  tsort(SimpleMp3Library, Smp3_Save.sortFieldLIB, Smp3_Save.sortOrderLIB)
end

-- Function to sort by length
function SimpleMp3LibraryForm_Button8()
  Smp3_Save.sortFieldLIB = 6
  Smp3_Save.sortOrderLIB = 1
  tsort(SimpleMp3Library, Smp3_Save.sortFieldLIB, Smp3_Save.sortOrderLIB)
end

-- Function to sort by bitrate
function SimpleMp3LibraryForm_Button9()
  Smp3_Save.sortFieldLIB = 7
  Smp3_Save.sortOrderLIB = 1
  tsort(SimpleMp3Library, Smp3_Save.sortFieldLIB, Smp3_Save.sortOrderLIB)
end
