-- MiniMap
function SimpleMp3_MiniMapOnload()
    this:RegisterForDrag("LeftButton");
    this:RegisterForClicks("LeftButtonUp", "RightButtonUp");
end

-- MiniMap Button Dragging Functions
function SimpleMp3_OnDragStart()
    if (not lbDraggingButton) then
            this:StartMoving();
            lbDraggingButton = true;
        end
end

function SimpleMp3_OnDragStop()
        if (lbDraggingButton) then
            this:StopMovingOrSizing()
            lbDraggingButton = false;
        end
end

--MiniMap Button Clicks
--Left click shows/hides the player
--Shift + left click = shows/hides the playlist
--Right click shows/hides the volume control
--Shift + right click shows/hides the library

function SimpleMp3_MinimapButtonClick(MouseButton)
    if (MouseButton == 'LeftButton' and IsShiftKeyDown() == nil) then
        if (SimpleMp3Form:IsVisible()) then
            SimpleMp3Form:Hide();
        else
            SimpleMp3Form:Show();
        end
    elseif (MouseButton == 'LeftButton' and IsShiftKeyDown()) then
        if (SimpleMp3PlaylistForm:IsVisible()) then
            SimpleMp3PlaylistForm:Hide();
        else
            SimpleMp3PlaylistForm:Show();
        end
    elseif (MouseButton == 'RightButton' and IsShiftKeyDown() == nil) then
        if (SimpleMp3VolumeForm:IsVisible()) then
            SimpleMp3VolumeForm:Hide();
        else
            SimpleMp3VolumeForm:Show();
        end
    elseif (MouseButton == 'RightButton' and IsShiftKeyDown()) then
        if (SimpleMp3LibraryForm:IsVisible()) then
            SimpleMp3LibraryForm:Hide();
        else
            SimpleMp3LibraryForm:Show();
        end
    end
end

-- Minimap Tooltip Text
function SimpleMp3MiniMap_OnEnter()
    GameTooltip:SetText(SIMPLEMP3_TOOLTIP_TITLE);
    GameTooltipTextLeft1:SetTextColor(1, 1, 1);
    GameTooltip:AddLine(SIMPLEMP3_TOOLTIP_TEXT);
    GameTooltip:Show();
end
