SimpleMp3PlayListTemp = {}
------------------------------------------------------
-- Playlist Functions
------------------------------------------------------

function SimpleMp3PlaylistForm_Info(x, num)
    if (Smp3_Save.SimpleMp3PlayList[1]) then
        if (x == 'song') then
            if (Smp3_Save.SimpleMp3PlayList[num].Title == 'None') then
                return string.gsub(Smp3_Save.SimpleMp3PlayList[num].Name, "^.+\\", "");
            else
                return Smp3_Save.SimpleMp3PlayList[num].Title;
            end
        elseif (x == 'artist') then
            if (Smp3_Save.SimpleMp3PlayList[num].Artist == 'None') then
                return SIMPLEMP3_UNK_ARTIST;
            else
                return Smp3_Save.SimpleMp3PlayList[num].Artist;
            end
        elseif (x == 'album') then
            if (Smp3_Save.SimpleMp3PlayList[num].Album == 'None') then
                return SIMPLEMP3_UNK_ALBUM;
            else
                return Smp3_Save.SimpleMp3PlayList[num].Album;
            end
        elseif (x == 'genre') then
            if (Smp3_Save.SimpleMp3PlayList[num].Genre == 'None') then
                return SIMPLEMP3_UNK_GENRE;
            else
                return Smp3_Save.SimpleMp3PlayList[num].Genre;
            end
        elseif (x == 'bitrate') then
            if (Smp3_Save.SimpleMp3PlayList[num].BitRate == 'None') then
                return SIMPLEMP3_UNK_BITRATE;
            else
                return Smp3_Save.SimpleMp3PlayList[num].BitRate;
            end
        elseif (x == 'name') then
            return Smp3_Save.SimpleMp3PlayList[num].Name;
        elseif (x == 'name2') then
            return string.gsub(Smp3_Save.SimpleMp3PlayList[num].Name, "^.+\\", "");
        elseif (x == 'length') then
            return Smp3_Save.SimpleMp3PlayList[num].Length;
        elseif (x == 'length2') then
            return Time(Smp3_Save.SimpleMp3PlayList[num].Length);
        end
    else
        return SIMPLEMP3_UNK
    end
end

function SimpleMp3PlaylistForm_Display(num)
    if (Smp3_Save.UseTags == true) then
        return SimpleMp3PlaylistForm_Info('song', num) .. " " .. "|cFFFFFFFF" .. SimpleMp3PlaylistForm_Info('artist', num) .. " " .. "|r" .. SimpleMp3PlaylistForm_Info('album', num) .. " ".. "|cFFFFFFFF"  .. SimpleMp3PlaylistForm_Info('genre', num) .. " " .. "|r" .. SimpleMp3PlaylistForm_Info('bitrate', num) .. "k " .. "|cFFFFFFFF" .. SimpleMp3PlaylistForm_Info('length2', num) .. "|r";
    else
        return SimpleMp3PlaylistForm_Info('name2', num) .. " " .. SimpleMp3PlaylistForm_Info('length2', num);
    end
end

-- Playlist Onshow tells it to update
function SimpleMp3PlaylistForm_OnShow()
    if (Smp3_Save.PlaySounds == true) then
        PlaySound("igCharacterInfoOpen");
    end
    Smp3_Save.wasVisiblePL = true;
    SimpleMp3PlaylistForm_Update()
end

function SimpleMp3PlaylistForm_OnHide()
    if (Smp3_Save.PlaySounds == true) then
        PlaySound("igCharacterInfoClose");
    end
    Smp3_Save.wasVisiblePL = false;
end

 -- When the scrollbar is changed so shall the list
function SimpleMp3PlaylistForm_OnValueChanged()
    SimpleMp3PlaylistForm_Update()
end

function SimpleMp3PlaylistForm_OnLoad()
    local LabelVar
    LabelVar = getglobal("SimpleMp3PlaylistForm" .. "TitleLabel" .. "Label");
    LabelVar:SetText(SIMPLEMP3_BINDPLAYLIST);
    LabelVar = getglobal("SimpleMp3PlaylistForm" .. "Button1");
    LabelVar:SetText(SIMPLEMP3_BINDREMALL_BN);
    LabelVar = getglobal("SimpleMp3PlaylistForm" .. "Button2");
    LabelVar:SetText(SIMPLEMP3_BINDREMSEL_BN);
    LabelVar = getglobal("SimpleMp3PlaylistForm" .. "Button3");
    LabelVar:SetText(SIMPLEMP3_SORTNAME);
    LabelVar = getglobal("SimpleMp3PlaylistForm" .. "Button4");
    LabelVar:SetText(SIMPLEMP3_SORTTITLE);
    LabelVar = getglobal("SimpleMp3PlaylistForm" .. "Button5");
    LabelVar:SetText(SIMPLEMP3_SORTARTIST);
    LabelVar = getglobal("SimpleMp3PlaylistForm" .. "Button6");
    LabelVar:SetText(SIMPLEMP3_SORTALBUM);
    LabelVar = getglobal("SimpleMp3PlaylistForm" .. "Button7");
    LabelVar:SetText(SIMPLEMP3_SORTGENRE);
    LabelVar = getglobal("SimpleMp3PlaylistForm" .. "Button8");
    LabelVar:SetText(SIMPLEMP3_SORTLENGTH);
    LabelVar = getglobal("SimpleMp3PlaylistForm" .. "Button9");
    LabelVar:SetText(SIMPLEMP3_SORTBITRATE);
    this:RegisterForDrag("LeftButton");
    SimpleMp3PlaylistForm_Update()
end

function SimpleMp3PlaylistForm_OnEvent()
end

-- Playlist form populates the list according to window size
local function SimpleMp3PlaylistForm_PopulateList()
    local LabelVar, SliderVar;
    SliderVar = getglobal("SimpleMp3PlaylistForm" .. "ListSlider");
    MaxPlayListNum = table.getn(Smp3_Save.SimpleMp3PlayList);

    if (MaxPlayListNum == 1) then
        LabelVar = getglobal("SimpleMp3PlaylistForm" .. "PanelBn" .. 1);
        LabelVar:SetText(SliderVar:GetValue() + 0 .. ". " .. SimpleMp3PlaylistForm_Display(SliderVar:GetValue() + 0));
   elseif (Smp3_Save.VisibleSlots <= MaxPlayListNum) then
        for i=1,Smp3_Save.VisibleSlots do
            LabelVar = getglobal("SimpleMp3PlaylistForm" .. "PanelBn" .. i);
            LabelVar:SetText(SliderVar:GetValue() + (i - 1) .. ". " .. SimpleMp3PlaylistForm_Display(SliderVar:GetValue() + (i - 1)));
        end
    else
        for i=1,MaxPlayListNum do
            LabelVar = getglobal("SimpleMp3PlaylistForm" .. "PanelBn" .. i);

            if (i > MaxPlayListNum) then
                return;
            end

            -- Debugging purposes while fixing playlist resizing issue
            SimpleMp3_Output(SliderVar:GetValue() .. " " .. i .. " " .. Smp3_Save.SimpleMp3PlayList[(SliderVar:GetValue() + i) - 1].Name, "debug");
            LabelVar:SetText(SliderVar:GetValue() + (i - 1) .. ". " .. SimpleMp3PlaylistForm_Display(SliderVar:GetValue() + (i - 1)));
        end
    end
end

-- Playlist update (text show/hide routine)
-- This tells the resizable window how many slots are viewable at that size
function SimpleMp3PlaylistForm_Update()
    if (SimpleMp3_Addon_Loaded == true) then
        if (Smp3_Save.SimpleMp3PlayList[1] == nil) then
            SimpleMp3PlaylistFormPanelBn1:Hide()
            Smp3_Save.VisibleSlots = 0;
        end
        MaxPlayListNum = table.getn(Smp3_Save.SimpleMp3PlayList);
        local fheight = SimpleMp3PlaylistForm:GetHeight()
        local SliderVar;
        SliderVar = getglobal("SimpleMp3PlaylistForm" .. "ListSlider");

        for i = 1, 25 do
            if (MaxPlayListNum >= i) then
                if ((i * 14) + 37.8 < fheight) then
                    x = 'SimpleMp3PlaylistFormPanelBn' .. i .. ':Show()'
                    RunScript(x)
                    SliderVar:SetMinMaxValues(1, SliderMax(table.getn(Smp3_Save.SimpleMp3PlayList), (i-1)));
                    Smp3_Save.VisibleSlots = i;
                else
                    x = 'SimpleMp3PlaylistFormPanelBn' .. i .. ':Hide()'
                    RunScript(x)
                end
            else
                x = 'SimpleMp3PlaylistFormPanelBn' .. i .. ':Hide()'
                RunScript(x)
                if (MaxPlayListNum == 0) then
                    Smp3_Save.VisibleSlots = 0;
                end
            end
        end
        -- Debugging purposes while fixing playlist issues
        -- SimpleMp3_Output(fheight, "debug");

        SimpleMp3PlaylistForm_PopulateList()
    end
end

-- Function for when something in the playlist is clicked
function SimpleMp3PlaylistForm_OnClick(MouseButton, Number)
    local SliderVar;
    SliderVar = getglobal("SimpleMp3PlaylistForm" .. "ListSlider");

    if (MouseButton == 'LeftButton' and IsControlKeyDown()) then
        if (Smp3_Save.PlaySounds == true) then
            PlaySound("igMiniMapZoomIn");
        end
        tinsert(SimpleMp3PlayListTemp, SliderVar:GetValue() + Number - 1);
    elseif (MouseButton == 'LeftButton' and IsShiftKeyDown()) then
        SimpleMp3PlaylistForm_Remove(Number);
    elseif (MouseButton == 'LeftButton') then
        if (isPlaying == true) then
            SimpleMp3Form_StopMusic();
            Smp3_Save.Current = (SliderVar:GetValue() + Number - 1);
            Smp3_Length = SimpleMp3PlaylistForm_Info('length', Smp3_Save.Current);
            SimpleMp3Form_StartMusic(SimpleMp3PlaylistForm_Info('name', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('song', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('artist', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('album', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('length2', Smp3_Save.Current), Smp3_Save.Current, false); -- FIXME
        else
            Smp3_Save.Current = (SliderVar:GetValue() + Number - 1);
            Smp3_Length = SimpleMp3PlaylistForm_Info('length', Smp3_Save.Current);
            SimpleMp3Form_StartMusic(SimpleMp3PlaylistForm_Info('name', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('song', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('artist', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('album', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('length2', Smp3_Save.Current), Smp3_Save.Current, true); -- FIXME
        end
    end
end

-- Playlist scroll function
function SimpleMp3PlaylistForm_OnMouseWheel(Direction)
    local SliderVar;
    SliderVar = getglobal("SimpleMp3PlaylistForm" .. "ListSlider");

    if (Direction == 1) then
        SliderVar:SetValue(SliderVar:GetValue() - 1);
    else
        SliderVar:SetValue(SliderVar:GetValue() + 1);
    end
end

-- Function to Remove All songs from the PlayList
function SimpleMp3PlaylistForm_Button1()
    if (Smp3_Save.isShuffled == false) then
        for i = 1, table.getn(Smp3_Save.SimpleMp3PlayList) do
            tremove(Smp3_Save.SimpleMp3PlayList);
        end
    else
        for i = 1, table.getn(Smp3_Save.SimpleMp3PlayList) do
            tremove(Smp3_Save.SimpleMp3PlayList);
        end
        Smp3_Save.isShuffled = false
        SetShuffleBnText(SIMPLEMP3_BINDSHUFFLEOFF)
        SimpleMp3_Output(SIMPLEMP3_SHUFFLEOFF);
    end
    SimpleMp3_Output("Removed all songs from Playlist", "debug");
    Smp3_Save.Current = 1
    if (isPlaying) then
        SimpleMp3Form_StopMusic();
    else
        SimpleMp3Form_ResetDisplay(SimpleMp3PlaylistForm_Info('name', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('song', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('artist', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('album', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('length2', Smp3_Save.Current), Smp3_Save.Current, true);
    end
    SimpleMp3PlaylistForm_Update()
    collectgarbage();
end

-- Function to Remove All Selected songs from the PlayList
function SimpleMp3PlaylistForm_Button2()
    if (SimpleMp3PlayListTemp == nil) then
        return
    end
    if (Smp3_Save.isShuffled == true) then
        SimpleMp3_Output(SIMPLEMP3_CANT_REMOVE, "error");
    else
        for i = 1, table.getn(SimpleMp3PlayListTemp) do
            tsort(SimpleMp3PlayListTemp, 8, 2)
            tremove(Smp3_Save.SimpleMp3PlayList, SimpleMp3PlayListTemp[i]);
            SimpleMp3_Output(SimpleMp3PlayListTemp[i], "debug")
        end
        for i = 1, table.getn(SimpleMp3PlayListTemp) do
            tremove(SimpleMp3PlayListTemp)
        end
        Smp3_Save.Current = 1
        if (isPlaying) then
            SimpleMp3Form_StopMusic();
        else
            SimpleMp3Form_ResetDisplay(SimpleMp3PlaylistForm_Info('name', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('song', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('artist', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('album', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('length2', Smp3_Save.Current), Smp3_Save.Current, true);
        end
        SimpleMp3PlaylistForm_Update()
        collectgarbage();
    end
end
-- Function to sort by name
function SimpleMp3PlaylistForm_Button3()
  Smp3_Save.sortFieldPL = 1
  Smp3_Save.sortOrderPL = 1
  tsort(Smp3_Save["SimpleMp3PlayList"], Smp3_Save.sortFieldPL, Smp3_Save.sortOrderPL)
end

-- Function to sort by title
function SimpleMp3PlaylistForm_Button4()
  Smp3_Save.sortFieldPL = 2
  Smp3_Save.sortOrderPL = 1
  tsort(Smp3_Save["SimpleMp3PlayList"], Smp3_Save.sortFieldPL, Smp3_Save.sortOrderPL)
end

-- Function to sort by artist
function SimpleMp3PlaylistForm_Button5()
  Smp3_Save.sortFieldPL = 3
  Smp3_Save.sortOrderPL = 1
  tsort(Smp3_Save["SimpleMp3PlayList"], Smp3_Save.sortFieldPL, Smp3_Save.sortOrderPL)
end

-- Function to sort by album
function SimpleMp3PlaylistForm_Button6()
  Smp3_Save.sortFieldPL = 4
  Smp3_Save.sortOrderPL = 1
  tsort(Smp3_Save["SimpleMp3PlayList"], Smp3_Save.sortFieldPL, Smp3_Save.sortOrderPL)
end

-- Function to sort by genre
function SimpleMp3PlaylistForm_Button7()
  Smp3_Save.sortFieldPL = 5
  Smp3_Save.sortOrderPL = 1
  tsort(Smp3_Save["SimpleMp3PlayList"], Smp3_Save.sortFieldPL, Smp3_Save.sortOrderPL)
end

-- Function to sort by length
function SimpleMp3PlaylistForm_Button8()
  Smp3_Save.sortFieldPL = 6
  Smp3_Save.sortOrderPL = 1
  tsort(Smp3_Save["SimpleMp3PlayList"], Smp3_Save.sortFieldPL, Smp3_Save.sortOrderPL)
end

-- Function to sort by bitrate
function SimpleMp3PlaylistForm_Button9()
  Smp3_Save.sortFieldPL = 7
  Smp3_Save.sortOrderPL = 1
  tsort(Smp3_Save["SimpleMp3PlayList"], Smp3_Save.sortFieldPL, Smp3_Save.sortOrderPL)
end

function SimpleMp3PlaylistForm_Remove(Number)
    local SliderVar;
    SliderVar = getglobal("SimpleMp3PlaylistForm" .. "ListSlider");

    if (Smp3_Save.isShuffled == true) then
        SimpleMp3_Output(SIMPLEMP3_CANT_REMOVE, "error");
    else
        if (Smp3_Save.PlaySounds == true) then
            PlaySound("igMiniMapZoomIn");
        end
        local name = SimpleMp3PlaylistForm_Info('name2', Number)
        MaxPlayListNum = table.getn(Smp3_Save.SimpleMp3PlayList);
        tremove(Smp3_Save.SimpleMp3PlayList, Number);
        if (Number == Smp3_Save.Current) then
            if (Smp3_Save.Current == MaxPlayListNum) then
                Smp3_Save.Current = 1
            else
                Smp3_Save.Current = Number
            end
            if (isPlaying) then
                SimpleMp3Form_StopMusic();
                SimpleMp3Form_StartMusic(SimpleMp3PlaylistForm_Info('name', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('song', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('artist', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('album', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('length2', Smp3_Save.Current), Smp3_Save.Current, true); -- FIXME
            else
                SimpleMp3Form_ResetDisplay(SimpleMp3PlaylistForm_Info('name', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('song', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('artist', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('album', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('length2', Smp3_Save.Current), Smp3_Save.Current, true);
            end
        elseif (Number < Smp3_Save.Current) then
            Smp3_Save.Current = Smp3_Save.Current - 1
            SimpleMp3Form_ResetDisplay(SimpleMp3PlaylistForm_Info('name', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('song', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('artist', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('album', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('length2', Smp3_Save.Current), Smp3_Save.Current, false);
        end
        SimpleMp3_Output("Removed "..name.." from Playlist", "debug");
    end
end
