-- Same for all locales

SIMPLEMP3_VERSION           = GetAddOnMetadata("SimpleMp3", "Version");

-- English localization:

SIMPLEMP3_TITLE                     = "SimpleMp3 Player";
SIMPLEMP3_TITLEBAR                  = SIMPLEMP3_TITLE .. " " .. SIMPLEMP3_VERSION;
SIMPLEMP3_NOWPLAY                   = "Now Playing: ";
SIMPLEMP3_SHUFFLEON                 = "SimpleMp3 Shuffle: Enabled";
SIMPLEMP3_SHUFFLEOFF                = "SimpleMp3 Shuffle: Disabled";
SIMPLEMP3_SLASHCOMMAND              = "SimpleMp3 Player Commands:";

-- don't translate the actual commands yet
SIMPLEMP3_SLASHCOMLIST              = "\n icon - Hide/Show Minimap Icon \n player - Hide/Show Player Interface \n playlist - Hide/Show Playlist \n volume - Hide/Show Volume Slider \n play - Starts Music \n stop - Stops Music \n next - Plays Next Track \n prev - Plays Previous Track"

SIMPLEMP3_BINDPLAYLIST              = "[Simple Mp3 Playlist]";
SIMPLEMP3_BINDLIBRARY               = "[Simple Mp3 Library]";
SIMPLEMP3_BINDNEXT                  = "Next";
SIMPLEMP3_BINDPREV                  = "Prev";
SIMPLEMP3_BINDSHUFFLEOFF            = "Shuffle";
SIMPLEMP3_BINDSHUFFLEON             = "UnShuffle";
SIMPLEMP3_BINDPLAY                  = "Play";
SIMPLEMP3_BINDSTOP                  = "Stop";
SIMPLEMP3_BINDLIB_BN                = "Library";
SIMPLEMP3_BINDPL_BN                 = "Playlist";
SIMPLEMP3_BINDADDALL_BN             = "Add All";
SIMPLEMP3_BINDREMALL_BN             = "Remove All";
SIMPLEMP3_BINDADDSEL_BN             = "Add Selected";
SIMPLEMP3_BINDREMSEL_BN             = "Remove Selected";
SIMPLEMP3_REMOVECURRENT_BN          = "Remove From Playlist";
SIMPLEMP3_BINDSORT_BN               = "Sort Now";
SIMPLEMP3_SHOWOUTPUT_BN             = "Show output";
SIMPLEMP3_HIDEOUTPUT_BN             = "Hide output";
SIMPLEMP3_BINDVOLUME                = "Volume";

-- misc text
SIMPLEMP3_UNK                       = "Unknown";
SIMPLEMP3_UNK_TITLE                 = "Unknown Title";
SIMPLEMP3_UNK_ARTIST                = "Unknown Artist";
SIMPLEMP3_UNK_ALBUM                 = "Unknown Album";
SIMPLEMP3_UNK_GENRE                 = "Unknown Genre";
SIMPLEMP3_UNK_BITRATE               = "Unknown BitRate";
SIMPLEMP3_BY                        = "by";
SIMPLEMP3_FROM                      = "from";
SIMPLEMP3_NEW_PL                    = "New Playlist Detected!";
SIMPLEMP3_CANT_REMOVE               = "Can't Remove Songs While Shuffled"
SIMPLEMP3_CANT_ADD                  = "Can't Add Songs While Shuffled"
SIMPLEMP3_SORTLIST                  = "Sort List";
SIMPLEMP3_SORTORDER                 = "Sort Order";
SIMPLEMP3_SORTFIELD                 = "Sort Field";
SIMPLEMP3_SORTPL_TT                 = "Sorts the PlayList";
SIMPLEMP3_SORTLIB_TT                = "Sorts the Library";
SIMPLEMP3_SORTASCEND                = "Ascending";
SIMPLEMP3_SORTASCEND_TT             = "Sort Ascending";
SIMPLEMP3_SORTDESCEND               = "Descending";
SIMPLEMP3_SORTDESCEND_TT            = "Sort Descending";
SIMPLEMP3_SORTNAME                  = "Name";
SIMPLEMP3_SORTNAME_TT               = "Sort by Filename";
SIMPLEMP3_SORTTITLE                 = "Title";
SIMPLEMP3_SORTTITLE_TT              = "Sort by Title";
SIMPLEMP3_SORTARTIST                = "Artist";
SIMPLEMP3_SORTARTIST_TT             = "Sort by Artist";
SIMPLEMP3_SORTALBUM                 = "Album";
SIMPLEMP3_SORTALBUM_TT              = "Sort by Album";
SIMPLEMP3_SORTGENRE                 = "Genre";
SIMPLEMP3_SORTGENRE_TT              = "Sort by Genre";
SIMPLEMP3_SORTLENGTH                = "Length";
SIMPLEMP3_SORTLENGTH_TT             = "Sort by Length";
SIMPLEMP3_SORTBITRATE               = "BitRate";
SIMPLEMP3_SORTBITRATE_TT            = "Sort by BitRate";
SIMPLEMP3_PLAYDELAY                 = "Play Delay";

-- Extra Spaces Intentional
SIMPLEMP3_DEFAULT_SCROLLTEXT        = "    The PlayList is empty, Open the Library and add some songs, or add them all.                "
SIMPLEMP3_DESC_TEXT                 = SIMPLEMP3_TITLEBAR..": Originally created by ".. GetAddOnMetadata("SimpleMp3", "X-Creator") .. ", Updated by the following (in order): " .. GetAddOnMetadata("SimpleMp3", "X-Maintainers")

-- don't translate the actual commands yet
SIMPLEMP3_ABOUT_TEXT                = "Console commands can be accessed by typing\n /smp3 command in your chat text.\nCurrent /smp3 commands are:\nIcon - Show/Hide MiniMap Icon\nPlayer - Show/Hide SimpleMp3 Player\nPlaylist - Show/Hide SimpleMp3 Playlist\nLibrary - Show/Hide SimpleMp3 Library\nPlay - Play Music\nStop - Stop Music\nPrev - Play previous track\nNext - Play Next track"
SIMPLEMP3_SOUNDCHECK_TEXT           = "Enable interface sounds";
SIMPLEMP3_MUTECHECK_TEXT            = "Play ingame music when SMp3 isn't playing";
SIMPLEMP3_TAGSCHECK_TEXT            = "Use ID3 tags to display Title, Artist, etc.";
SIMPLEMP3_PLAYONSTARTCHECK_TEXT     = "Play On Startup";
SIMPLEMP3_NEXTTRACK_TEXT            = "Play next track when resuming Playback";
SIMPLEMP3_VCVOLUMECONTROLCHECK_TEXT = "Lower the music volume when voice chatting";
SIMPLEMP3_SHOWOUTPUTCHECK_TEXT      = "Show all output in Default Chat Frame";
SIMPLEMP3_SHOWDEBUGCHECK_TEXT       = "Show Debug messages";

-- Key bindings:
BINDING_HEADER_SIMPLEMP3_TITLE      = SIMPLEMP3_TITLE;
BINDING_NAME_SIMPLEMP3_PLAYSTOP     = "Play/Stop";
BINDING_NAME_SIMPLEMP3_NEXT         = "Next";
BINDING_NAME_SIMPLEMP3_PREV         = "Previous";
BINDING_NAME_SIMPLEMP3_PLAYLIST     = "Playlist";
BINDING_NAME_SIMPLEMP3_LIBRARY      = "Library";
BINDING_NAME_SIMPLEMP3_PLAYER       = "Player";

-- Tooltip Text:
SIMPLEMP3_TOOLTIP_TITLE             = "        "..SIMPLEMP3_TITLE;
SIMPLEMP3_TOOLTIP_TEXT              = "-LMB shows the Player.\n-RMB shows the Volume Slider.\n-LMB+Shift shows the Playlist.\n-RMB+Shift shows the Library.\n-LMB+Drag moves the Frames.\n-M.Wheel Up/Down for Volume.";
SIMPLEMP3_TOOLTIP_TS_TITLE          = "   Switch Time";
SIMPLEMP3_TOOLTIP_TS_TEXT           = "Switch between \ntime elapsed and \ntime remaining.";
SIMPLEMP3_TOOLTIP_OP_TITLE          = " SimpleMp3 Options";
SIMPLEMP3_TOOLTIP_OP_TEXT           = "Open the SimpleMp3 \noptions page.";


--  à : \195\160    è : \195\168    ì : \195\172    ò : \195\178    ù : \195\185   Ä : \195\132
--  á : \195\161    é : \195\169    í : \195\173    ó : \195\179    ú : \195\186   Ö : \195\150
--  â : \195\162    ê : \195\170    î : \195\174    ô : \195\180    û : \195\187   Ü : \195\156
--  ã : \195\163    ë : \195\171    ï : \195\175    õ : \195\181    ü : \195\188   ß : \195\159
--  ä : \195\164                    ñ : \195\177    ö : \195\182
--  å : \195\165                    ø : \195\184
--  æ : \195\166
--  ç : \195\167
